#!/bin/ksh

LANG=C
PROPS_NAME=`basename $PROPSFILE`
PROPS_NAME=${PROPS_NAME%.*}
ACTUATOR_LOG="../log/${PROPS_NAME}.log";
PROPS_TEMP="${PROPSFILE}.new";
EXITCODE_FILE="itfim.failure"
JAVAPATH_FILE="java.path"
echo $OPTION4 > $JAVAPATH_FILE
export LANG PROPS_NAME ACTUATOR_LOG PROPS_TEMP JAVAPATH_FILE

../bin/getitfim_shared62.sh "$TEMPFILE2" "$OPTION2" "$OPTION5" "Runtime"
RUNTIME_RESULT=$?

if [ -f $EXITCODE_FILE ]; then
   MGMT_RESULT=`cat $EXITCODE_FILE`
else
   MGMT_RESULT=0
fi

RESULT_CODE=$RUNTIME_RESULT
case $RUNTIME_RESULT in
   1)
     if [ $MGMT_RESULT -eq 1 ]; then
        echo "[`date`] ERROR: Neither of required logs collected successfully." >> $ACTUATOR_LOG
     else
        RESULT_CODE=0
     fi
     ;;
   2) 
     if [ $MGMT_RESULT -eq 2 ]; then
        echo "[`date`] ERROR: Collect process cannot be completed due to previous errors." >> $ACTUATOR_LOG
     else
        RESULT_CODE=0
     fi
     ;;
esac

if [ $RESULT_CODE -eq 0 ]; then
   cat $PROPS_TEMP > $PROPSFILE
   [ $MGMT_RESULT -eq 0 ] && \
     echo "[`date`] The total number of new collected events from management log is `grep -c '<CommonBaseEvent ' "$TEMPFILE1"`." >> $ACTUATOR_LOG
   [ $RUNTIME_RESULT -eq 0 ] && \
     echo "[`date`] The total number of new collected events from runtime log is `grep -c '<CommonBaseEvent ' "$TEMPFILE2"`." >> $ACTUATOR_LOG
   echo "[`date`] Processing finished [SUCCESS]" >> $ACTUATOR_LOG
   rm $PROPS_TEMP
   exit 0
else
   echo "[`date`] Processing finished [FAILURE]" >> $ACTUATOR_LOG
   exit 1
fi
