@echo off
set TEMP_FILE1=%1
set HOST="empty"
set PORT=%3
set USER_NAME=%4
set PASSWORD=%5
set TIP_INSTALL_DIR=%6

for %%A in (%*) do set PROPS_FILE=%%A
echo PROPS_FILE %PROPS_FILE%

if "%PROPS_FILE%" == "" (
   set LOG_FILE="..\log\gettklmgroups.err"
) else (
   set LOG_FILE="..\log\%PROPS_FILE%.log"
)

if exist %PROPS_FILE% (
  findstr "SystemName" %PROPS_FILE%> nul
  if NOT errorlevel 1 (
    for /F "tokens=1,2 delims==" %%i in ('findstr "SystemName" %PROPS_FILE%') do (
     set HOST=%%j
    )
  ) 
) 

echo [%date%][%time%] Processing start. > %LOG_FILE%

if %TEMP_FILE1% EQU "" (
    echo [%date%][%time%]Failure: Missing output file argument>> %LOG_FILE%
    echo [%date%][%time%] Processing finished. [FAILURE]>> %LOG_FILE%
    exit /b 1
)
else
(
   type nul > "%TEMP_FILE1%"
)

if %HOST% EQU "empty" (
  echo Failure: Missing paramter SystemName from PROPS_FILE >> %LOG_FILE%
  echo [%date%][%time%] "Processing finished [FAILURE]">> %LOG_FILE%
  exit /b 1
)

if %PORT% EQU "" (
        echo [%date%][%time%] Failure: Missing WAS repository SOAP port argument>> %LOG_FILE%
    echo [%date%][%time%] Processing finished. [FAILURE]>> %LOG_FILE%
        exit /b 1
)


if %USER_NAME% EQU "" (
        echo [%date%][%time%] Warning: Missing Repository User argument>> %LOG_FILE%
)

if %PASSWORD% EQU "" (
        echo [%date%][%time%] Warning: Missing Repository Password argument>> %LOG_FILE%
)

if %TIP_INSTALL_DIR% EQU "" (
        echo [%date%][%time%] Failure: Missing WAS installation directory argument>> %LOG_FILE%
    echo [%date%][%time%] Processing finished. [FAILURE]>> %LOG_FILE%
        exit /b 1
) 

if %PROPS_FILE% EQU "" (
        echo [%date%][%time%] Failure: Missing argument PROPS_FILE >> %LOG_FILE%
    echo [%date%][%time%] Processing finished. [FAILURE]>> %LOG_FILE%
        exit /b 1
) 
if not exist "%PROPS_FILE%" (
        echo [%date%][%time%] Failure: Can not find props file. >> %LOG_FILE%
    echo [%date%][%time%] Processing finished. [FAILURE]>> %LOG_FILE%
        exit /b 1
)

set profileCmd="%TIP_INSTALL_DIR%"\properties\fsdb\_was_profile_default\default.bat
if exist "%profileCmd%" (
    echo [%date%][%time%] WebSphere component ['TIP installation directory'\properties\fsd\_was_profile_default\default.bat] found.>> %LOG_FILE%
) else (
    echo [%date%][%time%] WebSphere component  ['TIP installation directory'\properties\fsd\_was_profile_default\default.bat] not found. Check 'TIP installation directory' ES property.>> %LOG_FILE%
    echo [%date%][%time%] [%%TIP_INSTALL_DIR%%] %TIP_INSTALL_DIR% >> %LOG_FILE%
    echo [%date%][%time%] Processing finished. [FAILURE]>> %LOG_FILE%
    exit /b 1
)
@rem load environment variables so TIP will work
set CLIENTSSL=null
call "%profileCmd%"

if NOT exist "%WAS_USER_SCRIPT%" (
   echo [%date%][%time%] WebSphere component  [%WAS_USER_SCRIPT%] not found.>> %LOG_FILE%
   echo [%date%][%time%] [%%WAS_USER_SCRIPT%%] %WAS_USER_SCRIPT% >> %LOG_FILE%
   echo [%date%][%time%] Processing finished. [FAILURE]>> %LOG_FILE%
   exit /b 1
) else (
    echo [%date%][%time%] WebSphere component [%WAS_USER_SCRIPT%] found.>> %LOG_FILE%
)
 call "%WAS_USER_SCRIPT%"

set TRUSTFILE=%WAS_HOME%/profiles/TIPProfile/etc/DummyClientTrustFile.jks
set KEYFILE=%WAS_HOME%/profiles/TIPProfile/etc/DummyClientKeyFile.jks

if NOT exist "%TRUSTFILE%" (
    echo [%date%][%time%] Warning: trustfile: %TRUSTFILE% does not exist.  >> %LOG_FILE%
    set TRUSTFILE=remote
) else (
    echo [%date%][%time%] Found %TRUSTFILE%.  >> %LOG_FILE%
)
if NOT exist "%KEYFILE%" (
    echo [%date%][%time%] Warning: keyfile: %KEYFILE% does not exist.  >> %LOG_FILE%
    set KEYFILE=remote
) else (
    echo [%date%][%time%] Found %KEYFILE%.  >> %LOG_FILE%
)

set JAVA_BIN="%JAVA_HOME%\bin\java.exe"
if exist %JAVA_BIN% (
   echo [%date%][%time%] Use TIP Java machine: %JAVA_BIN%.  >> %LOG_FILE%
) else (
   echo [%date%][%time%] Failure: Can not found TIP Java machine: %JAVA_BIN%.  >> %LOG_FILE%
   exit /b 1
)

if "%CLIENTSSL%" EQU "null" (
@rem WAS V6.0
%JAVA_BIN% -Djava.security.auth.login.config="%WAS_HOME%/properties/wsjaas_client.conf" -Djava.ext.dirs="%JAVA_HOME%/jre/lib/ext;%WAS_HOME%/plugins;%WAS_EXT_DIRS%" -Dserver.root="%WAS_HOME%" -Duser.install.root="%USER_INSTALL_ROOT%" -classpath "%WAS_CLASSPATH%;%WAS_HOME%/lib/admin.jar;%WAS_HOME%/lib/utils.jar;%WAS_HOME%/lib/bootstrap.jar;%WAS_HOME%/lib/j2ee.jar;"..\bin\gettklmgroups.jar;. nl.consul.cea.gensub.itklmuis.java.GetTKLMGroups -host %HOST% -port %PORT% -username %USER_NAME% -password %PASSWORD% -trustfile %TRUSTFILE% -keyfile %KEYFILE% -chunk %TEMP_FILE1% -propsfile %PROPS_FILE% 1>> %LOG_FILE% 2>&1
if NOT errorlevel 1 (
  echo Collecting finished. >> %LOG_FILE%
) else (
    echo [%date%][%time%] Collect process failed >> %LOG_FILE%
    echo [%date%][%time%] Processing finished. [FAILURE] >> %LOG_FILE%
    exit /b 1
)
)
if "%CLIENTSSL%" NEQ "null" (
@rem V6.1 vs 7.0
%JAVA_BIN% -Djava.security.auth.login.config="%WAS_HOME%/properties/wsjaas_client.conf" -Djava.ext.dirs="%JAVA_HOME%/jre/lib/ext;%WAS_HOME%/plugins;%WAS_EXT_DIRS%" -Dserver.root="%WAS_HOME%" "%CLIENTSAS%" "%CLIENTSSL%" -Duser.install.root="%USER_INSTALL_ROOT%" -classpath "%WAS_CLASSPATH%;%WAS_HOME%/lib/admin.jar;%WAS_HOME%/lib/utils.jar;%WAS_HOME%/lib/bootstrap.jar;%WAS_HOME%/lib/j2ee.jar;"..\bin\gettklmgroups.jar;. nl.consul.cea.gensub.itklmuis.java.GetTKLMGroups -host %HOST% -port %PORT% -username %USER_NAME% -password %PASSWORD% -trustfile %TRUSTFILE% -keyfile %KEYFILE% -chunk %TEMP_FILE1% -propsfile %PROPS_FILE% 1>> %LOG_FILE% 2>&1
   if NOT errorlevel 1 (
        echo Collecting finished. >> %LOG_FILE%
    ) else (
        echo [%date%][%time%] Collect process failed >> %LOG_FILE%
        echo [%date%][%time%] Processing finished. [FAILURE] >> %LOG_FILE%
        exit /b 1
    )
)
echo [%date%][%time%] Processing finished. [SUCCESS]  >> %LOG_FILE%
