#!/bin/ksh
TEMPFILE=$TEMPFILE1
LOG_LOCATION=$OPTION2
LOG_TMPL=$OPTION3
PROPS_FILE=$PROPSFILE
touch $TEMPFILE

if [ -z $PROPS_FILE]; then
   act_log_file="../log/gettklmlogs.err"
   echo "[`date`] Failure: Missing property file argument">>$act_log_file
   exit 1
fi

act_log_file="../log/`basename $PROPS_FILE`.log"
[ -f "$PROPS_FILE" ] || touch "$PROPS_FILE"

if [ -z $LOG_LOCATION]; then
   echo "[`date`] Failure: Missing log location argument">>$act_log_file
   exit 1
fi

if [ -z $LOG_TMPL]; then
   echo "[`date`] Failure: Missing logfile mask (main log file name) argument">>$act_log_file
   exit 1
fi 


echo "[`date`] Processing started.">$act_log_file
 
JAVA_PATH=`which java`
if [ -f "$JAVA_PATH" -a -x "$JAVA_PATH" ]; then
   echo "[`date`] Found Java binary file: '${JAVA_PATH}'." >> $act_log_file
else
   echo "[`date`] ERROR: Java binary file not found." >> $act_log_file
   exit 1
fi

"$JAVA_PATH" \
  -classpath "../bin/gettklmlogs.jar" \
  nl.consul.cea.gensub.itklm.java.GetTKLMLogs \
  "$LOG_LOCATION" \
  "$LOG_TMPL" \
  "$TEMPFILE" \
  "$PROPS_FILE" \
  UNIX 2>>$act_log_file 1>>$act_log_file
  
code=$?
if [ $code = 0 ]; then
   echo "[`date`] Processing finished. [SUCCESS]">>$act_log_file
   exit 0
else
   echo "[`date`] Processing finished. [FAILURE]">>$act_log_file
   exit 1
fi