@echo off
set TEMP_FILE=%1
rem WAS parameters
rem set WAS_HOST=%2
set WAS_PORT=%3
set WAS_USER_NAME=%4
set WAS_PASSWORD=%5
set WAS_INSTALL_DIR=%6

rem LDAP parameters
set LDAP_HOST=%7
set LDAP_PORT=%8
set LDAP_USER_OBJECTCLASS=%9
shift /1
set LDAP_GROUP_OBJECTCLASS=%9
shift /1
set LDAP_USER_BASEDN=%9
shift /1
set LDAP_GROUP_BASEDN=%9
shift /1
set LDAP_USERID_ATTRIBUTE=%9
shift /1
set LDAP_AUTHID_ATTRIBUTE=%9
shift /1
set LDAP_GROUPNAME_ATTRIBUTE=%9
shift /1
set LDAP_SEARCH_DN=%9
shift /1
set LDAP_SEARCH_PW=%9
shift /1
set LDAP_GROUP_LOOKUP_METHOD=%9
shift /1
set LDAP_GROUP_LOOKUP_ATTRIBUTE=%9
shift /1
rem DB2 parameters

set DB_HOST=%9
shift /1
set DB_PORT=%9
shift /1
set DB_USERNAME=%9
shift /1
set DB_PASSWORD=%9
shift /1
set DB_NAME=%9
shift /1
set DB_SCHEMA=%9

for %%A in (%*) do set PROPS_FILE=%%A
rem echo PROPS_FILE %PROPS_FILE%
set LOG_FILE="..\log\%PROPS_FILE%.log"

rem checking tempfile
if %TEMP_FILE%=="" (
 echo [%date%][%time%] TEMP_FILE is not defined. >> %LOG_FILE%
 exit /b 1
)

rem defining WAS_HOST
for /F "tokens=1,2 delims='='" %%i in (%PROPS_FILE%) do ( 
   if "%%i"=="SystemName" (
     for /F "tokens=1,2 delims= " %%a in ('echo %%j') do (
        set WAS_HOST=%%a
       )
     )
     
   if "%%i"=="SystemName " (
     for /F "tokens=1,2 delims= " %%a in ('echo %%j') do (
        set WAS_HOST=%%a
       )
     ) 
   )

rem checking WAS parameters
if %WAS_HOST%=="" (
 echo [%date%][%time%] WAS host is not defined. >> %LOG_FILE%
 exit /b 1
)
@echo %WAS_HOST% | findstr /R "[<>?*/|]"> nul && echo [%date%] [%time%] WAS host contains illegal characters. > %LOG_FILE% && exit /b 1

if %WAS_PORT%=="" (
 echo [%date%][%time%] WAS port is not defined. >> %LOG_FILE%
 exit /b 1
)
@echo %WAS_PORT% | findstr /R "[a-za-Z<>?*/|]"> nul && echo [%date%] [%time%] WAS port contains illegal characters. >> %LOG_FILE% && exit /b 1

if %WAS_INSTALL_DIR%=="" (
 echo [%date%][%time%] WAS installation directory is not defined. >> %LOG_FILE%
 exit /b 1
)
@echo %WAS_INSTALL_DIR% | findstr /R "[<>?*/|]"> nul && echo [%date%] [%time%] WAS installation directory contains illegal characters. >> %WAS_INSTALL_DIR% && exit /b 1

if %WAS_USER_NAME%=="" (
 echo [%date%][%time%] WAS user name is not defined. >> %LOG_FILE%
 exit /b 1
)

if %WAS_PASSWORD%=="" (
 echo [%date%][%time%] WAS password is not defined. >> %LOG_FILE%
 exit /b 1
)

if %PROPS_FILE%=="" (
 echo [%date%][%time%] propsfile is not defined. >> %LOG_FILE%
 exit /b 1
)

echo [%date%][%time%] Processing started. > %LOG_FILE%
@rem no profile so use default
set profileCmd="%WAS_INSTALL_DIR%"\properties\fsdb\_was_profile_default\default.bat

if exist "%profileCmd%" (
    echo [%date%][%time%] WebSphere component ['WAS installation directory'/properties/fsdb/_was_profile_default/default.bat] found.>> %LOG_FILE%
) else (
    echo [%date%][%time%] WebSphere component  ['WAS installation directory'/properties/fsdb/_was_profile_default/default.bat] not found. Check 'WAS installation directory' ES property.>> %LOG_FILE%
    echo [%date%][%time%] [%%WAS_INSTALL_DIR%%] %WAS_INSTALL_DIR% >> %LOG_FILE%
    echo [%date%][%time%] Processing finished. [FAILURE]>> %LOG_FILE%
    exit /b 1
)
@rem load environment variables so WAS will work
 call "%profileCmd%"
 if NOT exist "%WAS_USER_SCRIPT%" (
    echo [%date%][%time%] WebSphere component  [%WAS_USER_SCRIPT%] not found.>> %LOG_FILE%
    echo [%date%][%time%] [%%WAS_USER_SCRIPT%%] %WAS_USER_SCRIPT% >> %LOG_FILE%
    echo [%date%][%time%] Processing finished. [FAILURE]>> %LOG_FILE%
    exit /b 1
) else (
    echo [%date%][%time%] WebSphere component [%WAS_USER_SCRIPT%] found.>> %LOG_FILE%
)
 call "%WAS_USER_SCRIPT%"

@rem V6.1
rem if exist "%WAS_HOME%\bin\ProfileManagement\plugins\com.ibm.websphere.v61_6.1.200\ws_runtime.jar" (
     "%JAVA_HOME%/bin/java"  -Dfile.encoding=UTF-8 -Djava.security.auth.login.config="%WAS_HOME%/properties/wsjaas_client.conf" -Dws.ext.dirs="%WAS_EXT_DIRS%;%WAS_USER_DIRS%;." -Djava.naming.factory.initial=com.ibm.websphere.naming.WsnInitialContextFactory  -Dserver.root="%WAS_HOME%" "%CLIENTSAS%" "%CLIENTSSL%"  "-Dcom.ibm.CORBA.loginSource"=none -Duser.install.root="%USER_INSTALL_ROOT%" -classpath "%WAS_CLASSPATH%";"%WAS_HOME%\plugins\com.ibm.ws.security.crypto_6.1.0.jar";"%WAS_HOME%\bin\ProfileManagement\plugins\com.ibm.websphere.v61_6.1.200\ws_runtime.jar";"%WAS_HOME%\runtimes\com.ibm.ws.webservices.thinclient_6.1.0.jar";../bin/gettspmgroups.jar;. nl.consul.cea.gensub.itspmuis.java.GetTSPMGroups -host %WAS_HOST% -port %WAS_PORT% -username %WAS_USER_NAME% -password %WAS_PASSWORD% -chunk %TEMP_FILE% -propsfile %PROPS_FILE% 1>> %LOG_FILE% 2>&1
rem ) else (
@rem TIP !!!!!!!!!!izmenit put' k klassu v finalnoy versii!!!!!!!!!!!
rem "%JAVA_HOME%/bin/java"  -Djava.security.auth.login.config="%WAS_HOME%/properties/wsjaas_client.conf" -Djava.ext.dirs="%JAVA_HOME%/jre/lib/ext;%WAS_HOME%/plugins;%WAS_EXT_DIRS%" -Dserver.root="%WAS_HOME%" "%CLIENTSAS%" "%CLIENTSSL%" -Duser.install.root="%USER_INSTALL_ROOT%" -classpath "%WAS_CLASSPATH%;%WAS_HOME%/lib/admin.jar;%WAS_HOME%/lib/utils.jar;%WAS_HOME%/lib/bootstrap.jar;%WAS_HOME%/lib/j2ee.jar;"../bin/gettspmgroups.jar;. nl.consul.cea.gensub.itspmuis.java.GetTSPMGroups -host %WAS_HOST% -port %WAS_PORT% -username %WAS_USER_NAME% -password %WAS_PASSWORD% -trustfile %TRUSTFILE% -keyfile %KEYFILE% -showlog %SHOWLOG_PATH% -chunk %TEMP_FILE% -propsfile %PROPS_FILE% 1>> %LOG_FILE% 2>&1
rem )
if %ERRORLEVEL% NEQ 0 (
    echo [%date%][%time%] Unable to collect WAS grouping.>> %LOG_FILE%
    echo [%date%][%time%] Processing finished. [FAILURE]>> %LOG_FILE%
    exit /b 1
   ) else (
        echo [%date%][%time%] WAS grouping is collected successfully.>> %LOG_FILE%
   )

echo [%date%][%time%] Starting collect LDAP grouping.>> %LOG_FILE%
rem checking LDAP parameters
if %LDAP_HOST%=="" (
 echo [%date%][%time%] LDAP host is not defined - collect will be skipped. >> %LOG_FILE%
 goto :DB
)
@echo %LDAP_HOST% | findstr /R "[<>?*/|]"> nul && echo [%date%] [%time%] LDAP port contains illegal characters. >> %LOG_FILE% && goto :END

if %LDAP_PORT%=="" (
 echo [%date%][%time%] LDAP host is not defined. >> %LOG_FILE%
 goto :ENDLDAP
)
@echo %LDAP_PORT% | findstr /R "[<>?*/|]"> nul && echo [%date%] [%time%] LDAP host contains illegal characters. >> %LOG_FILE% && goto :ENDLDAP

if %LDAP_USER_OBJECTCLASS%=="" (
 echo [%date%][%time%] LDAP port is not defined. >> %LOG_FILE%
 goto :ENDLDAP
)
@echo %LDAP_USER_OBJECTCLASS% | findstr /R "[<>?*/|]"> nul && echo [%date%] [%time%] LDAP user object class contains illegal characters. >> %LOG_FILE% && goto :ENDLDAP

if %LDAP_GROUP_OBJECTCLASS%=="" (
 echo [%date%][%time%] LDAP group object class is not defined. >> %LOG_FILE%
 exit /b 0
)
@echo %LDAP_GROUP_OBJECTCLASS% | findstr /R "[<>?*/|]"> nul && echo [%date%] [%time%] LDAP group object class contains illegal characters. >> %LOG_FILE% goto :ENDLDAP

if %LDAP_USER_BASEDN%=="" (
 echo [%date%][%time%] LDAP user base DN is not defined. >> %LOG_FILE%
 goto :ENDLDAP
)

if %LDAP_GROUP_BASEDN%=="" (
 echo [%date%][%time%] LDAP group base DN is not defined. >> %LOG_FILE%
 goto :ENDLDAP
)

if %LDAP_USERID_ATTRIBUTE%=="" (
 echo [%date%][%time%] LDAP user ID attribute is not defined. >> %LOG_FILE%
 goto :ENDLDAP
)

if %LDAP_AUTHID_ATTRIBUTE%=="" (
 echo [%date%][%time%] LDAP auth ID attribute is not defined. >> %LOG_FILE%
 goto :ENDLDAP
)

if %LDAP_GROUPNAME_ATTRIBUTE%=="" (
 echo [%date%][%time%] LDAP groupname attribute is not defined. >> %LOG_FILE%
 goto :ENDLDAP
)

if %LDAP_SEARCH_DN%=="" (
 echo [%date%][%time%] LDAP login is not defined. >> %LOG_FILE%
 goto :ENDLDAP
)

if %LDAP_SEARCH_PW%=="" (
 echo [%date%][%time%] LDAP password is not defined. >> %LOG_FILE%
 goto :ENDLDAP
)

if %LDAP_GROUP_LOOKUP_METHOD%=="" (
 echo [%date%][%time%] LDAP group lookup method is not defined. >> %LOG_FILE%
 goto :ENDLDAP
)

if %LDAP_GROUP_LOOKUP_ATTRIBUTE%=="" (
 echo [%date%][%time%] LDAP group lookup attribute is not defined. >> %LOG_FILE%
 goto :ENDLDAP
)

"%JAVA_HOME%/bin/java" -classpath "..\bin\gettspmgroups.jar" nl.consul.cea.gensub.itspmuis.java.CollectTspmLdapGroups -LDAPHost?"%LDAP_HOST%" -LDAPPort?"%LDAP_PORT%" -UserName?"%LDAP_SEARCH_DN%" -Password?"%LDAP_SEARCH_PW%" -USER_BASEDN?"%LDAP_USER_BASEDN%" -AUTHID_ATTRIBUTE?"%LDAP_AUTHID_ATTRIBUTE%" -USER_OBJECTCLASS?"%LDAP_USER_OBJECTCLASS%" -GROUP_OBJECTCLASS?"%LDAP_GROUP_OBJECTCLASS%" -GROUP_BASEDN?"%LDAP_GROUP_BASEDN%" -GROUPNAME_ATTRIBUTE?"%LDAP_GROUPNAME_ATTRIBUTE%" -GROUP_LOOKUP_METHOD?"%LDAP_GROUP_LOOKUP_METHOD%" -GROUP_LOOKUP_ATTRIBUTE?"%LDAP_GROUP_LOOKUP_ATTRIBUTE%" -Filename?"%TEMP_FILE%.ldap" 1>> %LOG_FILE% 2>&1

if %ERRORLEVEL% NEQ 0 (
    goto :ENDLDAP
   )

if exist "%TEMP_FILE%.ldap" ( 
   type "%TEMP_FILE%.ldap" >> "%TEMP_FILE%"
   del "%TEMP_FILE%.ldap"
   echo [%date%][%time%] LDAP grouping is collected successfully.>> %LOG_FILE%
)

rem goto END
:DB
rem checking DB parameters
echo [%date%][%time%] Starting collect DB2 grouping.>> %LOG_FILE%
if %DB_HOST%=="" (
 echo [%date%][%time%] Database host is not defined. >> %LOG_FILE%
 goto :ENDDB
)
@echo %DB_HOST% | findstr /R "[<>?*/|]"> nul && echo [%date%] [%time%] Database host contains illegal characters. >> %LOG_FILE% && exit /b 1

if %DB_PORT%=="" (
 echo [%date%][%time%] Database port is not defined - collect will be skipped. >> %LOG_FILE%
 goto :ENDDB
)
@echo %DB_PORT% | findstr /R "[a-za-Z<>?*/|]"> nul && echo [%date%] [%time%] Database port contains illegal characters. >> %LOG_FILE% && exit /b 1

if %DB_USERNAME%=="" (
 echo [%date%][%time%] Database login is not defined. >> %LOG_FILE%
 goto :ENDDB
)

if %DB_PASSWORD%=="" (
 echo [%date%][%time%] Database password is not defined. >> %LOG_FILE%
 goto :ENDDB
)

if %DB_SCHEMA%=="" (
 echo [%date%][%time%] Database schema is not defined. >> %LOG_FILE%
 goto :ENDDB
)

if %DB_NAME%=="" (
 echo [%date%][%time%] Database name is not defined. >> %LOG_FILE%
 goto :ENDDB
)

rem building groups within administrative roles
echo SELECT %DB_SCHEMA%.ADMINROLE.NAME, %DB_SCHEMA%.ADMINGROUP.REALM_UNIQUE_SECURITY_NAME FROM %DB_SCHEMA%.ADMINROLE, %DB_SCHEMA%.ADMINROLE_GROUPS, %DB_SCHEMA%.ADMINGROUP WHERE %DB_SCHEMA%.ADMINROLE.ID=%DB_SCHEMA%.ADMINROLE_GROUPS.ID_OID AND %DB_SCHEMA%.ADMINGROUP.ID=%DB_SCHEMA%.ADMINROLE_GROUPS.ID_EID > %PROPS_FILE%.sql_groups

"%JAVA_HOME%/bin/java" -Dfile.encoding=UTF-8 -classpath "%CLASSPATH%;../bin/jdbc-genact.jar" eprise.audit.chunktool.generic.java.JdbcGenact -driver=DB2 -host="%DB_HOST%" -port="%DB_PORT%" -database="%DB_NAME%" -username="%DB_USERNAME%" -passwd="%DB_PASSWORD%" -props="%PROPS_FILE%.tmp" -outfilename="%TEMP_FILE%.db_groups" -sqlfilename="%PROPS_FILE%.sql_groups" -useheaderline=no  -separator=";" -eraseoutfile=yes >> %LOG_FILE%
if %ERRORLEVEL% NEQ 0 (
    goto :ENDDB
   )

if exist "%TEMP_FILE%.db_groups" (
echo [SourceGroup] > %PROPS_FILE%.db
echo [%date%][%time%] Collecting groups within administrative roles. >> %LOG_FILE%
for /F "tokens=1,2,3 delims=;" %%i in ('type %TEMP_FILE%.db_groups') do (
      echo "%%j role" >> %PROPS_FILE%.db
      echo { >> %PROPS_FILE%.db
      echo   in src_group "%%k">> %PROPS_FILE%.db
      echo } >> %PROPS_FILE%.db
     )
)
rem building users within administrative roles   
echo SELECT %DB_SCHEMA%.ADMINROLE.NAME, %DB_SCHEMA%.ADMINUSER.REALM_UNIQUE_SECURITY_NAME FROM %DB_SCHEMA%.ADMINROLE, %DB_SCHEMA%.ADMINROLE_USERS, %DB_SCHEMA%.ADMINUSER WHERE %DB_SCHEMA%.ADMINROLE.ID=%DB_SCHEMA%.ADMINROLE_USERS.ID_OID AND %DB_SCHEMA%.ADMINUSER.ID=%DB_SCHEMA%.ADMINROLE_USERS.ID_EID > %PROPS_FILE%.sql_users

"%JAVA_HOME%/bin/java" -Dfile.encoding=UTF-8 -classpath "%CLASSPATH%;../bin/jdbc-genact.jar" eprise.audit.chunktool.generic.java.JdbcGenact -driver=DB2 -host="%DB_HOST%" -port="%DB_PORT%" -database="%DB_NAME%" -username="%DB_USERNAME%" -passwd="%DB_PASSWORD%" -props="%PROPS_FILE%.tmp" -outfilename="%TEMP_FILE%.db.users" -sqlfilename="%PROPS_FILE%.sql_users" -useheaderline=no  -separator=";" -eraseoutfile=no >> %LOG_FILE%
if %ERRORLEVEL% NEQ 0 (
    goto :ENDDB
   )
   
if exist "%TEMP_FILE%.db_users" (
echo [SourceGroup] >> %PROPS_FILE%.db
echo [%date%][%time%] Collecting users within administrative roles. >> %LOG_FILE%
for /F "tokens=1,2,3 delims=;" %%i in ('type %TEMP_FILE%.db_users') do (
      echo "%%j role" >> %PROPS_FILE%.db
      echo { >> %PROPS_FILE%.db
      echo   match logonname "%%k">> %PROPS_FILE%.db
      echo } >> %PROPS_FILE%.db
     )
)

if exist "%PROPS_FILE%.db" (
   type %PROPS_FILE%.db >> %TEMP_FILE%
)

rem resolving users ID's
echo SELECT DN, NAME FROM %DB_SCHEMA%."USER" > %PROPS_FILE%.sql_uid

"%JAVA_HOME%/bin/java" -Dfile.encoding=UTF-8 -classpath "%CLASSPATH%;../bin/jdbc-genact.jar" eprise.audit.chunktool.generic.java.JdbcGenact -driver=DB2 -host="%DB_HOST%" -port="%DB_PORT%" -database="%DB_NAME%" -username="%DB_USERNAME%" -passwd="%DB_PASSWORD%" -props="%PROPS_FILE%.tmp" -outfilename="%TEMP_FILE%.db.uid" -sqlfilename="%PROPS_FILE%.sql_uid" -useheaderline=no  -separator=";" -eraseoutfile=yes >> %LOG_FILE%
if %ERRORLEVEL% NEQ 0 (
    goto :ENDDB
   )

if exist "%TEMP_FILE%.db.uid" (
echo [Persons] > %PROPS_FILE%.db.uid
echo [%date%][%time%] Collecting users. >> %LOG_FILE%
for /F "tokens=1,2,3 delims=;" %%i in ('type %TEMP_FILE%.db.uid') do (
      echo "%%k" "%%k" "0">> %PROPS_FILE%.db.uid
      echo { >> %PROPS_FILE%.db.uid
      echo   match logonname "%%j">> %PROPS_FILE%.db.uid
      echo } >> %PROPS_FILE%.db.uid
     )
)

if exist "%PROPS_FILE%.db.uid" (
   type %PROPS_FILE%.db.uid >> %TEMP_FILE%
)

echo [%date%][%time%] Database grouping is collected successfully.>> %LOG_FILE%
goto :END

:ENDLDAP
echo [%date%][%time%] Unable to collect LDAP grouping.>> %LOG_FILE%
goto :DB

:ENDDB
echo [%date%][%time%] Unable to collect DB2 grouping.>> %LOG_FILE%
goto :END

:END
if exist %TEMP_FILE1% del %PROPS_FILE%.db
if exist %PROPS_FILE%.sql_users del %PROPS_FILE%.sql_users
if exist %PROPS_FILE%.sql_groups del %PROPS_FILE%.sql_groups
if exist %PROPS_FILE%.sql_uid del %PROPS_FILE%.sql_uid
if exist %PROPS_FILE%.db del %PROPS_FILE%.db
if exist %TEMP_FILE%.db_users del %TEMP_FILE%.db_users
if exist %TEMP_FILE%.db_groups del %TEMP_FILE%.db_groups
if exist %TEMP_FILE%.db.uid del %TEMP_FILE%.db.uid
if exist %PROPS_FILE%.db.uid del %PROPS_FILE%.db.uid
echo [%date%][%time%] Processing finished [SUCCESS].>> %LOG_FILE%

