#!/bin/ksh

LANG=C
PROPS_NAME=`basename $PROPSFILE`
PROPS_NAME=${PROPS_NAME%.*}
ACTUATOR_LOG="../log/${PROPS_NAME}.log";
PROPS_TEMP="${PROPSFILE}.new";
EXITCODE_FILE="tspm.failure"
JAVAPATH_FILE="java.path"
export LANG PROPS_NAME ACTUATOR_LOG PROPS_TEMP JAVAPATH_FILE

../bin/gettspmshared.sh "$TEMPFILE2" "$OPTION2" "$OPTION4" "RTSS"
RTSS_RESULT=$?

if [ -f $EXITCODE_FILE ]; then
   TSPM_RESULT=`cat $EXITCODE_FILE`
else
   TSPM_RESULT=0
fi

RESULT_CODE=$RTSS_RESULT
case $RTSS_RESULT in
   1)
     if [ $TSPM_RESULT -eq 1 ]; then
        echo "[`date`] ERROR: Neither of required logs collected successfully." >> $ACTUATOR_LOG
     else
        RESULT_CODE=0
     fi
     ;;
   2) 
     if [ $TSPM_RESULT -eq 2 ]; then
        echo "[`date`] ERROR: Collect process cannot be completed due to previous errors." >> $ACTUATOR_LOG
     else
        RESULT_CODE=0
     fi
     ;;
esac

if [ $RESULT_CODE -eq 0 ]; then
   cat $PROPS_TEMP > $PROPSFILE
   [ $TSPM_RESULT -eq 0 ] && \
     echo "[`date`] The total number of new collected events from TSPM log is `grep -c '<CommonBaseEvent ' "$TEMPFILE1"`." >> $ACTUATOR_LOG
   [ $RTSS_RESULT -eq 0 ] && \
     echo "[`date`] The total number of new collected events from RTSS log is `grep -c '<CommonBaseEvent ' "$TEMPFILE2"`." >> $ACTUATOR_LOG
   echo "[`date`] Processing finished [SUCCESS]" >> $ACTUATOR_LOG
   exit 0
else
   echo "[`date`] Processing finished [FAILURE]" >> $ACTUATOR_LOG
   exit 1
fi
