#!/bin/ksh
TEMP_FILE=$1
CFGDIR=$3
PROPS_FILE=$4

failure()
{
  echo "[`date`] ERROR: $1.">>$ES_LOG
  echo "[`date`] Processing finished. [FAILURE]">>$ES_LOG
  exit 1
}

if [ -z "$PROPS_FILE" ]; then
   ES_LOG="../log/getsapjsgroups.err"
   >$ES_LOG 
   failure "Missing property file argument"
fi
PROPS_NAME=`basename $PROPS_FILE`
PROPS_NAME=${PROPS_NAME%.*} 
ES_LOG="../log/${PROPS_NAME}.log"; 
>$ES_LOG 
>$TEMP_FILE 
if [ $? -ne 0 ]; then
   failure "Unable to create temporary file '${TEMP_FILE}'"
fi  
echo "[`date`] Processing started. " >> $ES_LOG
if [ -z "$CFGDIR" ]; then
   failure "Missing path to cfg file directory argument"
fi

cp $CFGDIR $TEMP_FILE
if [ $? -ne 0 ]; then
   failure "File $CFGDIR was not copied"
fi
echo "[`date`] File $CFGDIR was copied successfully." >> $ES_LOG
echo "[`date`] Processing finished [SUCCESS]. " >> $ES_LOG
exit 0
