#!/bin/ksh

# active log file
PROPS_NAME=`basename $PROPSFILE` 
PROPS_NAME=${PROPS_NAME%.*} 
CHUNKS_DIR="/tmp/ES-${PROPS_NAME}"
ES_LOG="../log/${PROPS_NAME}.log"

print_message()
{
  echo "$(date "+[%Y-%m-%d %H:%M:%S]") ${1}" >> "${ES_LOG}"
}

if [ -f ${CHUNKS_DIR}/* ]; then
   WORK_DIR="$(pwd)"
   print_message "Copy original logfiles to second chunk."
   cd ${CHUNKS_DIR} >> ${WORK_DIR}/${ES_LOG} 2>&1
   FC=$(echo "$1" | sed 's/^\(.\).*/\1/')
   if [ "${FC}" = "/" ]; then
      TARBALL="$1"
   else
      TARBALL="${WORK_DIR}/$1"
   fi 
   tar -cf "$TARBALL" $(find ./ -type f) 2>>${WORK_DIR}/${ES_LOG}
   RC=$?
   cd ${WORK_DIR}
else
   >"$1"
   RC=0
fi
rm -fr ${CHUNKS_DIR}

if [ ${RC} -eq 0 ]; then
   print_message "Processing finished [SUCCESS]."
else
   print_message "ERROR: Failure copying original logfiles to second chunk."
fi
exit $RC
