@echo off
set TEMPFILE1=%~1
set TEMPFILE2=%~2
set TEMPFILE3=%~3
set DBTYPE=%~4
set DBNAME=%~5
set DBSCHEMA=%~6
set PORT=%~7
set USERNAME=%~8
set PASSWORD=%~9
for %%I in (%*) do set PROPSFILE=%%~I

rem -- sets actuator log name
if "%PROPSFILE%" == "" (
   set ACTUATOR_LOG="..\log\gettamessologs.err"
) else (
   set ACTUATOR_LOG="..\log\%PROPSFILE%.log"
)

echo [%date%][%time%] Processing started. >%ACTUATOR_LOG% 2>&1

if "%TEMPFILE1%" == "" (
    echo [%date%][%time%] temporary file 1 location is not specified. >>%ACTUATOR_LOG% 2>&1
    echo [%date%][%time%] Processing finished [FAILURE]. >>%ACTUATOR_LOG% 2>&1
    exit /b 1
)

if "%TEMPFILE2%" == "" (
    echo [%date%][%time%] temporary file 2 location is not specified. >>%ACTUATOR_LOG% 2>&1
    echo [%date%][%time%] Processing finished [FAILURE]. >>%ACTUATOR_LOG% 2>&1
    exit /b 1
)

if "%TEMPFILE3%" == "" (
    echo [%date%][%time%] temporary file 3 location is not specified. >>%ACTUATOR_LOG% 2>&1
    echo [%date%][%time%] Processing finished [FAILURE]. >>%ACTUATOR_LOG% 2>&1
    exit /b 1
)

rem defining DBHOST
for /F "tokens=1,2 delims='='" %%i in (%PROPSFILE%) do ( 
   if "%%i"=="SystemName" (
     for /F "tokens=1,2 delims= " %%a in ('echo %%j') do (
        set DBHOST=%%a
       )
     )
     
   if "%%i"=="SystemName " (
     for /F "tokens=1,2 delims= " %%a in ('echo %%j') do (
        set DBHOST=%%a
       )
     ) 
   )
   
if "%DBHOST%" == "" (
    echo [%date%][%time%] Database host is not specified. >>%ACTUATOR_LOG% 2>&1
    echo [%date%][%time%] Processing finished [FAILURE]. >>%ACTUATOR_LOG% 2>&1
    exit /b 1
)
echo %DBHOST% | findstr /R "[!()\/@*&$*]" > nul
if %ERRORLEVEL% EQU 0 (
    echo [%date%][%time%] Hostname contains illegal characters. >>%ACTUATOR_LOG% 2>&1
    echo [%date%][%time%] Processing finished [FAILURE]. >>%ACTUATOR_LOG% 2>&1
    exit /b 1
)

if "%PORT%" == "" (
    echo [%date%][%time%] Database host is not specified. >>%ACTUATOR_LOG% 2>&1
    echo [%date%][%time%] Processing finished [FAILURE]. >>%ACTUATOR_LOG% 2>&1
    exit /b 1
)
echo %PORT% | findstr /R "[!()\/@*&$*A-Za-z]" > nul
if %ERRORLEVEL% EQU 0 (
    echo [%date%][%time%] Port contains illegal characters. >>%ACTUATOR_LOG% 2>&1
    echo [%date%][%time%] Processing finished [FAILURE]. >>%ACTUATOR_LOG% 2>&1
    exit /b 1
)

if "%DBNAME%" == "" (
    echo [%date%][%time%] Database name is not specified. >>%ACTUATOR_LOG% 2>&1
    echo [%date%][%time%] Processing finished [FAILURE]. >>%ACTUATOR_LOG% 2>&1
    exit /b 1
)

if "%USERNAME%" == "" (
    echo [%date%][%time%] User name is not specified. >>%ACTUATOR_LOG% 2>&1
    echo [%date%][%time%] Processing finished [FAILURE]. >>%ACTUATOR_LOG% 2>&1
    exit /b 1
)

if "%PASSWORD%" == "" (
    echo [%date%][%time%] Password is not specified. >>%ACTUATOR_LOG% 2>&1
    echo [%date%][%time%] Processing finished [FAILURE]. >>%ACTUATOR_LOG% 2>&1
    exit /b 1
)

if "%DBSCHEMA%" == "" (
    echo [%date%][%time%] Database schema is not specified. >>%ACTUATOR_LOG% 2>&1
    echo [%date%][%time%] Processing finished [FAILURE]. >>%ACTUATOR_LOG% 2>&1
    exit /b 1
)

set DBTYPE_OK=0
if "%DBTYPE%" == "DB2" (
    echo [%date%][%time%] Database type is %DBTYPE%. >>%ACTUATOR_LOG% 2>&1
    set DBTYPE_OK=1
)
if "%DBTYPE%" == "Oracle" (
    echo [%date%][%time%] Database type is %DBTYPE%. >>%ACTUATOR_LOG% 2>&1
    set DBTYPE_OK=1
)
if "%DBTYPE%" == "MS SQL" (
    echo [%date%][%time%] Database type is %DBTYPE%. >>%ACTUATOR_LOG% 2>&1
    set DBTYPE_OK=1
)
if "%DBTYPE_OK%" == "0" (
    echo [%date%][%time%] Wrong database type is specified. Using DB2 by default. >>%ACTUATOR_LOG% 2>&1
    set DBTYPE=DB2
)

echo [%date%][%time%] Checking Java binary availability. >>%ACTUATOR_LOG% 2>&1
where java > nul 2>&1
if %ERRORLEVEL% EQU 1 (
    echo [%date%][%time%] Java binary is not found. >>%ACTUATOR_LOG% 2>&1
    echo [%date%][%time%] Processing finished [FAILURE]. >>%ACTUATOR_LOG% 2>&1
    exit /b 1
)

echo SELECT * FROM %DBSCHEMA%.IMSLOGUserActivity > IMSLOGUserActivity_%PROPSFILE%.sql
echo SELECT * FROM %DBSCHEMA%.IMSLOGUserAdminActivity > IMSLOGUserAdminActivity_%PROPSFILE%.sql
echo SELECT * FROM %DBSCHEMA%.IMSLOGUserService > IMSLOGUserService_%PROPSFILE%.sql

set COLLECT_SUCCESSFUL=1
echo [%date%][%time%] Collecting IMSLOGUserActivity table. >>%ACTUATOR_LOG% 2>&1
java -Dfile.encoding=UTF-8 -classpath "%JDBCDRIVERPATH%;../bin/jdbc-genact.jar" eprise.audit.chunktool.generic.java.JdbcGenact -driver="%DBTYPE%" -host="%DBHOST%" -port="%PORT%" -database="%DBNAME%" -username="%USERNAME%" -passwd="%PASSWORD%" -props="%PROPSFILE%" -outfilename="%TEMPFILE1%" -sqlfilename="IMSLOGUserActivity_%PROPSFILE%.sql" -useheaderline=yes  -separator=";" -eraseoutfile=yes -tdcolumn=logTime >>%ACTUATOR_LOG% 2>&1
if %ERRORLEVEL% EQU 0 (
    set COLLECT_SUCCESSFUL=0
)

echo [%date%][%time%] Collecting IMSLOGUserAdminActivity table. >>%ACTUATOR_LOG% 2>&1
java -Dfile.encoding=UTF-8 -classpath "%JDBCDRIVERPATH%;../bin/jdbc-genact.jar" eprise.audit.chunktool.generic.java.JdbcGenact -driver="%DBTYPE%" -host="%DBHOST%" -port="%PORT%" -database="%DBNAME%" -username="%USERNAME%" -passwd="%PASSWORD%" -props="%PROPSFILE%" -outfilename="%TEMPFILE2%" -sqlfilename="IMSLOGUserAdminActivity_%PROPSFILE%.sql" -useheaderline=yes  -separator=";" -eraseoutfile=yes -tdcolumn=logTime >>%ACTUATOR_LOG% 2>&1
if %ERRORLEVEL% EQU 0 (
    set COLLECT_SUCCESSFUL=0
)

echo [%date%][%time%] Collecting IMSLOGUserService table. >>%ACTUATOR_LOG% 2>&1
java -Dfile.encoding=UTF-8 -classpath "%JDBCDRIVERPATH%;../bin/jdbc-genact.jar" eprise.audit.chunktool.generic.java.JdbcGenact -driver="%DBTYPE%" -host="%DBHOST%" -port="%PORT%" -database="%DBNAME%" -username="%USERNAME%" -passwd="%PASSWORD%" -props="%PROPSFILE%" -outfilename="%TEMPFILE3%" -sqlfilename="IMSLOGUserService_%PROPSFILE%.sql" -useheaderline=yes  -separator=";" -eraseoutfile=yes -tdcolumn=logTime >>%ACTUATOR_LOG% 2>&1
if %ERRORLEVEL% EQU 0 (
    set COLLECT_SUCCESSFUL=0
)

if %COLLECT_SUCCESSFUL% EQU 1 (
    echo [%date%][%time%] None of the tables are collected succsessfully. >>%ACTUATOR_LOG% 2>&1
    echo [%date%][%time%] Processing finished [FAILURE]. >>%ACTUATOR_LOG% 2>&1
    exit /b 1
)

echo [%date%][%time%] Clearing temporary files. >>%ACTUATOR_LOG% 2>&1
del IMSLOGUserActivity_%PROPSFILE%.sql
del IMSLOGUserAdminActivity_%PROPSFILE%.sql
del IMSLOGUserService_%PROPSFILE%.sql

echo [%date%][%time%] Processing finished [SUCCESS]. >>%ACTUATOR_LOG% 2>&1
exit /b 0

